allocator_type
array
array_t
at
at
at
at
back
back
basic_json
basic_json
basic_json
basic_json
basic_json
basic_json
basic_json
basic_json
basic_json
basic_json
basic_json
basic_json
basic_json
basic_json
basic_json
basic_json
basic_json
basic_json
basic_json
basic_json
basic_json
begin
begin
boolean_t
cbegin
cend
clear
const_pointer
const_reference
const_reverse_iterator
count
crbegin
crend
difference_type
dump
empty
end
end
erase
erase
erase
erase
find
find
front
front
get
get
get
get_allocator
get_ptr
get_ptr
get_ref
get_ref
insert
insert
insert
insert
insert
is_array
is_boolean
is_discarded
is_null
is_number
is_number_float
is_number_integer
is_object
is_primitive
is_string
is_structured
iterator_wrapper
iterator_wrapper
max_size
number_float_t
number_integer_t
object
object_t
operator value_t
operator ValueType
operator!=
operator!=
operator!=
operator+=
operator+=
operator+=
operator<
operator<
operator<<
operator<<
operator<=
operator=
operator==
operator==
operator==
operator>
operator>=
operator>>
operator>>
operator[]
operator[]
operator[]
operator[]
operator[]
operator[]
operator[]
operator[]
parse
parse
parse
parse_event_t
parser_callback_t
pointer
push_back
push_back
push_back
rbegin
rbegin
reference
rend
rend
reverse_iterator
size
size_type
string_t
swap
swap
swap
swap
type
value
value
value_t
value_type
~basic_json

template<template< typename U, typename V, typename...Args > class ObjectType = std::map, template< typename U, typename...Args > class ArrayType = std::vector, class StringType = std::string, class BooleanType = bool, class NumberIntegerType = int64_t, class NumberFloatType = double, template< typename U > class AllocatorType = std::allocator>
template<typename ReferenceType , typename std::enable_if< std::is_reference< ReferenceType >::value , int >::type = 0>

ReferenceType nlohmann::basic_json::get_ref | ( |  | ) |

inline

Implict reference access to the internally stored JSON value. No copies are made.

Warning
  Writing data to the referee of the result yields an undefined state.

Template Parameters

  ReferenceType | reference type; must be a reference to array_t, object_t, string_t, boolean_t, number_integer_t, or number_float_t.

Returns
  reference to the internally stored JSON value if the requested reference type ReferenceType fits to the JSON value; throws std::domain_error otherwise

Exceptions

  std::domain_error | in case passed type ReferenceType is incompatible with the stored JSON value

Complexity
  Constant.

Example
  The example shows several calls to `get_ref()`.
  #include <json.hpp>
  using namespace nlohmann;
  int main()
  {
  // create a JSON number
  json value = 17;
  // explicitly getting references
  auto r1 = value.get_ref<const json::number_integer_t&>();
  auto r2 = value.get_ref<json::number_integer_t&>();
  // print the values
  std::cout << r1 << ' ' << r2 << '\n';
  // incompatible type throws exception
  try
  {
  auto r3 = value.get_ref<json::number_float_t&>();
  }
  catch (std::domain_error& ex)
  {
  std::cout << ex.what() << '\n';
  }
  }
  nlohmann::basic_json
  a class to store JSON values
  Definition: json.hpp:191
  nlohmann::basic_json::get_ref
  ReferenceType get_ref()
  get a reference value (implicit)
  Definition: json.hpp:2634
  nlohmann
  namespace for Niels Lohmann
  Definition: json.hpp:88
  nlohmann::basic_json::number_integer_t
  NumberIntegerType number_integer_t
  a type for a number (integer)
  Definition: json.hpp:537
  nlohmann::basic_json::number_float_t
  NumberFloatType number_float_t
  a type for a number (floating-point)
  Definition: json.hpp:602
  Output (play with this example online):

      17 17
      incompatible ReferenceType for get_ref, actual type is number

  The example code above can be translated with

      g++ -std=c++11 -Isrc doc/examples/get_ref.cpp -o get_ref

Since
  version 1.1.0

Definition at line 2634 of file json.hpp.